var MapView = {
};

(function() {

    var mapView = null;
    var map = null;
    var isAndroid = false;

    function updateCurrentLocation(e) {
        Titanium.API.debug('updateCurrentLocation(e) - BEGIN');

        if (!e.success || e.error) {
            Ti.API.debug("Error: "+e.error);
        } else {
            Ti.API.debug("e.coords.latitude: " + e.coords.latitude);
            Ti.API.debug(" e.coords.longitude: " + e.coords.longitude);
            if(map !== null) {
                map.setLocation({
                    latitude:e.coords.latitude,
                    longitude:e.coords.longitude,
                    animate:true
                });
            }
        }

        Titanium.API.debug('updateCurrentLocation(e) - END');
    }

    function updateMapRegion(e) {
        Titanium.API.debug('updateMapRegion(e) - BEGIN');

        Ti.API.debug('e.latitude  = ' + e.latitude);
        Ti.API.debug('e.longitude = ' + e.longitude);

        Titanium.API.debug('updateMapRegion(e) - END');
    }

    function setInitialLocation(e) {

        Titanium.API.debug('setInitialLocation(e) - BEGIN');

        if (!e.success || e.error) {
            Ti.API.debug("Error: "+e.error);
            return;
        }

        Titanium.API.info('geo - current location: ' + ' long ' + e.coords.latitude + ' lat ' + e.coords.longitude);

        if(map === null) {

            map = Titanium.Map.createView({
                mapType: Titanium.Map.STANDARD_TYPE,
                region: {
                    latitude:e.coords.latitude,
                    longitude:e.coords.longitude,
                    latitudeDelta:0.007,
                    longitudeDelta:0.007
                },
                animate:true,
                regionFit:true,
                userLocation:true
            });

            mapView.add(map);

            mapView.addEventListener('regionChanged', updateMapRegion);
            Titanium.Geolocation.addEventListener('location', updateCurrentLocation);

        } else {
            updateCurrentLocation(e);
        }

        Titanium.API.debug('setInitialLocation(e) - END');

    }

    function configureAppListeners() {
        Titanium.API.debug('configureAppListeners() - BEGIN');

        if (isAndroid) {
            //  as the destroy handler will remove the listener, only set the pause handler to remove if you need battery savings
            Ti.Android.currentActivity.addEventListener('pause', function(e) {
                Ti.API.info("pause event received");

                Titanium.Geolocation.removeEventListener('location', updateCurrentLocation);
                if(mapView !== null) {
                    mapView.removeEventListener('regionChanged', updateMapRegion);
                }
            });
            Ti.Android.currentActivity.addEventListener('resume', function(e) {
                Ti.API.info("resume event received");

                Titanium.Geolocation.addEventListener('location', updateCurrentLocation);
                if(mapView !== null) {
                    mapView.addEventListener('regionChanged', updateMapRegion);
                }
            });
            Ti.Android.currentActivity.addEventListener('resumed', function(e) {
                Ti.API.info("resumed event received");

                Titanium.Geolocation.addEventListener('location', updateCurrentLocation);
                if(mapView !== null) {
                    mapView.addEventListener('regionChanged', updateMapRegion);
                }
            });
        } else {
            Titanium.App.addEventListener('pause', function(e) {
                Ti.API.info("pause event received");
            });
            Titanium.App.addEventListener('resume', function(e) {
                Ti.API.info("resume event received");
            });
            Titanium.App.addEventListener('resumed', function(e) {
                Ti.API.info("resumed event received");
            });
        }

        Titanium.API.debug('configureAppListeners() - END');

    }

    function initializeThreatMap() {
        Titanium.API.debug('ThreatMapView.createThreatMap() - BEGIN');

        if (Titanium.Platform.name == 'android') {
            isAndroid = true;
        }

        configureAppListeners();

        if(Titanium.Platform.model == 'Simulator' || Titanium.Platform.model == "sdk" || Titanium.Platform.model == "google_sdk") {
            var coords = {
                latitude: 39.4316215,
                longitude: -119.7709939
            };
            var e = {
                coords: coords,
                success: true,
                error:''
            };
            setInitialLocation(e);
        } else {
            Titanium.Geolocation.getCurrentPosition( setInitialLocation );
        }

        Titanium.API.debug('ThreatMapView.createThreatMap() - END');
    }

    MapView.createMapView = function(args) {

        mapView = Titanium.UI.createView({
            backgroundColor:'#fff'
        });

        initializeThreatMap();

        return mapView;
    };
})();
Titanium.UI.currentWindow.add(MapView.createMapView());