// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#000');


var isAndroid = false;

if (Titanium.Platform.name == 'android') {
    isAndroid = true;
}


if (Titanium.Geolocation.locationServicesEnabled===false) {
    Titanium.UI.createAlertDialog({
        title:'TC-105',
        message:'Please turn on location services.'
    }).show();
}

if (!isAndroid) {
    var authorization = Titanium.Geolocation.locationServicesAuthorization;
    Ti.API.info('Authorization: '+authorization);
    if (authorization == Titanium.Geolocation.AUTHORIZATION_DENIED) {
        Ti.UI.createAlertDialog({
            title:'TC=105',
            message:'You have disallowed TC-105 from running geolocation services.'
        }).show();
    } else if (authorization == Titanium.Geolocation.AUTHORIZATION_RESTRICTED) {
        Ti.UI.createAlertDialog({
            title:'TC-105',
            message:'Your system has disallowed TC-105 from running geolocation services.'
        }).show();
    }

}

Titanium.Geolocation.purpose = "TC-105 Threat Level";
Titanium.Geolocation.preferredProvider = Titanium.Geolocation.PROVIDER_GPS;

//
//  SET ACCURACY - THE FOLLOWING VALUES ARE SUPPORTED
//
// Titanium.Geolocation.ACCURACY_BEST
// Titanium.Geolocation.ACCURACY_NEAREST_TEN_METERS
// Titanium.Geolocation.ACCURACY_HUNDRED_METERS
// Titanium.Geolocation.ACCURACY_KILOMETER
// Titanium.Geolocation.ACCURACY_THREE_KILOMETERS
//
Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_BEST;

Titanium.Geolocation.distanceFilter = 50;



// create tab group
var tabGroup = Titanium.UI.createTabGroup();

//
// create base UI tab and root window
//
var win1 = Titanium.UI.createWindow({
    title:'Tab 1',
    backgroundColor:'#fff'
});
var tab1 = Titanium.UI.createTab({
    icon:'KS_nav_views.png',
    title:'Tab 1',
    window:win1
});

var label1 = Titanium.UI.createLabel({
    color:'#999',
    text:'I am Window 1',
    font: {
        fontSize:20,
        fontFamily:'Helvetica Neue'
    },
    textAlign:'center',
    width:'auto'
});

win1.add(label1);

//
// create controls tab and root window
//
var win2 = Titanium.UI.createWindow({
    url:'MapView.js',
    title:'Tab 2',
    backgroundColor:'#fff'
});
var tab2 = Titanium.UI.createTab({
    icon:'KS_nav_ui.png',
    title:'Tab 2',
    window:win2
});

//
//  add tabs
//
tabGroup.addTab(tab1);
tabGroup.addTab(tab2);

// open tab group
tabGroup.open();